"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  cloneErrorObject: () => cloneErrorObject,
  cloneObject: () => cloneObject,
  formatError: () => formatError,
  transformError: () => transformError
});
module.exports = __toCommonJS(utils_exports);
var import_lodash = __toESM(require("@modern-js/utils/lodash"));
var import_formatter = require("../formatter");
const cloneObject = (error) => {
  const cloned = Object.create(Object.getPrototypeOf(error));
  return import_lodash.default.merge(cloned, error);
};
const cloneErrorObject = (error) => {
  const cloned = cloneObject(error);
  for (const k of Object.getOwnPropertyNames(error)) {
    cloned[k] || (cloned[k] = error[k]);
  }
  return cloned;
};
const transformError = (transformers, error) => {
  return transformers.reduce((error2, transformer) => transformer(error2) || error2, error);
};
const formatError = (formatters = [
  import_formatter.baseFormatter
], error) => {
  let formatted = "";
  for (const formatter of formatters) {
    var _formatter;
    formatted = (_formatter = formatter(error)) !== null && _formatter !== void 0 ? _formatter : formatted;
    if (formatted) {
      break;
    }
  }
  return formatted !== null && formatted !== void 0 ? formatted : (0, import_formatter.baseFormatter)(error);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  cloneErrorObject,
  cloneObject,
  formatError,
  transformError
});
